Index: protocols/msn/msn.c
===================================================================
--- protocols/msn/msn.c	(revision fa29d09342c79b886efacee4cfc3078be5f5a722)
+++ protocols/msn/msn.c	(revision 0da65d5fb37691ed4d31f7ab4058732f1440db6b)
@@ -29,5 +29,5 @@
 static char *msn_set_display_name( set_t *set, char *value );
 
-static void msn_acc_init( account_t *acc )
+static void msn_init( account_t *acc )
 {
 	set_t *s;
@@ -39,36 +39,36 @@
 static void msn_login( account_t *acc )
 {
-	struct gaim_connection *gc = new_gaim_conn( acc );
+	struct im_connection *ic = new_gaim_conn( acc );
 	struct msn_data *md = g_new0( struct msn_data, 1 );
 	
-	gc->proto_data = md;
+	ic->proto_data = md;
 	md->fd = -1;
 	
 	if( strchr( acc->user, '@' ) == NULL )
 	{
-		hide_login_progress( gc, "Invalid account name" );
-		signoff( gc );
+		hide_login_progress( ic, "Invalid account name" );
+		signoff( ic );
 		return;
 	}
 	
-	set_login_progress( gc, 1, "Connecting" );
-	
-	md->fd = proxy_connect( "messenger.hotmail.com", 1863, msn_ns_connected, gc );
+	set_login_progress( ic, 1, "Connecting" );
+	
+	md->fd = proxy_connect( "messenger.hotmail.com", 1863, msn_ns_connected, ic );
 	if( md->fd < 0 )
 	{
-		hide_login_progress( gc, "Could not connect to server" );
-		signoff( gc );
+		hide_login_progress( ic, "Could not connect to server" );
+		signoff( ic );
 		return;
 	}
 	
-	md->gc = gc;
+	md->ic = ic;
 	md->away_state = msn_away_state_list;
 	
-	msn_connections = g_slist_append( msn_connections, gc );
-}
-
-static void msn_close( struct gaim_connection *gc )
-{
-	struct msn_data *md = gc->proto_data;
+	msn_connections = g_slist_append( msn_connections, ic );
+}
+
+static void msn_logout( struct im_connection *ic )
+{
+	struct msn_data *md = ic->proto_data;
 	GSList *l;
 	
@@ -96,5 +96,5 @@
 				m = l->data;
 			
-				serv_got_crap( gc, "Warning: Closing down MSN connection with unsent message to %s, you'll have to resend it.", m->who );
+				serv_got_crap( ic, "Warning: Closing down MSN connection with unsent message to %s, you'll have to resend it.", m->who );
 				g_free( m->who );
 				g_free( m->text );
@@ -111,21 +111,21 @@
 	}
 	
-	for( l = gc->permit; l; l = l->next )
+	for( l = ic->permit; l; l = l->next )
 		g_free( l->data );
-	g_slist_free( gc->permit );
-	
-	for( l = gc->deny; l; l = l->next )
+	g_slist_free( ic->permit );
+	
+	for( l = ic->deny; l; l = l->next )
 		g_free( l->data );
-	g_slist_free( gc->deny );
-	
-	msn_connections = g_slist_remove( msn_connections, gc );
-}
-
-static int msn_send_im( struct gaim_connection *gc, char *who, char *message, int len, int away )
+	g_slist_free( ic->deny );
+	
+	msn_connections = g_slist_remove( msn_connections, ic );
+}
+
+static int msn_send_im( struct im_connection *ic, char *who, char *message, int away )
 {
 	struct msn_switchboard *sb;
-	struct msn_data *md = gc->proto_data;
-	
-	if( ( sb = msn_sb_by_handle( gc, who ) ) )
+	struct msn_data *md = ic->proto_data;
+	
+	if( ( sb = msn_sb_by_handle( ic, who ) ) )
 	{
 		return( msn_sb_sendmessage( sb, message ) );
@@ -142,5 +142,5 @@
 		
 		/* FIXME: *CHECK* the reliability of using spare sb's! */
-		if( ( sb = msn_sb_spare( gc ) ) )
+		if( ( sb = msn_sb_spare( ic ) ) )
 		{
 			debug( "Trying to use a spare switchboard to message %s", who );
@@ -160,5 +160,5 @@
 		/* If we reach this line, there was no spare switchboard, so let's make one. */
 		g_snprintf( buf, sizeof( buf ), "XFR %d SB\r\n", ++md->trId );
-		if( !msn_write( gc, buf, strlen( buf ) ) )
+		if( !msn_write( ic, buf, strlen( buf ) ) )
 		{
 			g_free( m->who );
@@ -180,5 +180,5 @@
 }
 
-static GList *msn_away_states( struct gaim_connection *gc )
+static GList *msn_away_states( struct im_connection *ic )
 {
 	static GList *l = NULL;
@@ -192,5 +192,5 @@
 }
 
-static char *msn_get_status_string( struct gaim_connection *gc, int number )
+static char *msn_get_status_string( struct im_connection *ic, int number )
 {
 	const struct msn_away_state *st = msn_away_state_by_number( number );
@@ -202,8 +202,8 @@
 }
 
-static void msn_set_away( struct gaim_connection *gc, char *state, char *message )
+static void msn_set_away( struct im_connection *ic, char *state, char *message )
 {
 	char buf[1024];
-	struct msn_data *md = gc->proto_data;
+	struct msn_data *md = ic->proto_data;
 	const struct msn_away_state *st;
 	
@@ -217,39 +217,39 @@
 	
 	g_snprintf( buf, sizeof( buf ), "CHG %d %s\r\n", ++md->trId, st->code );
-	msn_write( gc, buf, strlen( buf ) );
-}
-
-static void msn_set_info( struct gaim_connection *gc, char *info )
-{
-	msn_set_display_name( set_find( &gc->acc->set, "display_name" ), info );
-}
-
-static void msn_get_info(struct gaim_connection *gc, char *who) 
+	msn_write( ic, buf, strlen( buf ) );
+}
+
+static void msn_set_my_name( struct im_connection *ic, char *info )
+{
+	msn_set_display_name( set_find( &ic->acc->set, "display_name" ), info );
+}
+
+static void msn_get_info(struct im_connection *ic, char *who) 
 {
 	/* Just make an URL and let the user fetch the info */
-	serv_got_crap( gc, "%s\n%s: %s%s", _("User Info"), _("For now, fetch yourself"), PROFILE_URL, who );
-}
-
-static void msn_add_buddy( struct gaim_connection *gc, char *who )
-{
-	msn_buddy_list_add( gc, "FL", who, who );
-}
-
-static void msn_remove_buddy( struct gaim_connection *gc, char *who, char *group )
-{
-	msn_buddy_list_remove( gc, "FL", who );
-}
-
-static int msn_chat_send( struct conversation *c, char *message )
+	serv_got_crap( ic, "%s\n%s: %s%s", _("User Info"), _("For now, fetch yourself"), PROFILE_URL, who );
+}
+
+static void msn_add_buddy( struct im_connection *ic, char *who, char *group )
+{
+	msn_buddy_list_add( ic, "FL", who, who );
+}
+
+static void msn_remove_buddy( struct im_connection *ic, char *who, char *group )
+{
+	msn_buddy_list_remove( ic, "FL", who );
+}
+
+static void msn_chat_send( struct groupchat *c, char *message, int flags )
 {
 	struct msn_switchboard *sb = msn_sb_by_chat( c );
 	
 	if( sb )
-		return( msn_sb_sendmessage( sb, message ) );
-	else
-		return( 0 );
-}
-
-static void msn_chat_invite( struct conversation *c, char *msg, char *who )
+		msn_sb_sendmessage( sb, message );
+	/* FIXME: Error handling (although this can't happen unless something's
+	   already severely broken) disappeared here! */
+}
+
+static void msn_chat_invite( struct groupchat *c, char *msg, char *who )
 {
 	struct msn_switchboard *sb = msn_sb_by_chat( c );
@@ -263,5 +263,5 @@
 }
 
-static void msn_chat_leave( struct conversation *c )
+static void msn_chat_leave( struct groupchat *c )
 {
 	struct msn_switchboard *sb = msn_sb_by_chat( c );
@@ -271,11 +271,11 @@
 }
 
-static struct conversation *msn_chat_open( struct gaim_connection *gc, char *who )
+static struct groupchat *msn_chat_with( struct im_connection *ic, char *who )
 {
 	struct msn_switchboard *sb;
-	struct msn_data *md = gc->proto_data;
+	struct msn_data *md = ic->proto_data;
 	char buf[1024];
 	
-	if( ( sb = msn_sb_by_handle( gc, who ) ) )
+	if( ( sb = msn_sb_by_handle( ic, who ) ) )
 	{
 		debug( "Converting existing switchboard to %s to a groupchat", who );
@@ -286,5 +286,5 @@
 		struct msn_message *m;
 		
-		if( ( sb = msn_sb_spare( gc ) ) )
+		if( ( sb = msn_sb_spare( ic ) ) )
 		{
 			debug( "Trying to reuse an existing switchboard as a groupchat with %s", who );
@@ -299,5 +299,5 @@
 		/* Request a new switchboard. */
 		g_snprintf( buf, sizeof( buf ), "XFR %d SB\r\n", ++md->trId );
-		if( !msn_write( gc, buf, strlen( buf ) ) )
+		if( !msn_write( ic, buf, strlen( buf ) ) )
 			return( 0 );
 		
@@ -317,27 +317,27 @@
 }
 
-static void msn_keepalive( struct gaim_connection *gc )
-{
-	msn_write( gc, "PNG\r\n", strlen( "PNG\r\n" ) );
-}
-
-static void msn_add_permit( struct gaim_connection *gc, char *who )
-{
-	msn_buddy_list_add( gc, "AL", who, who );
-}
-
-static void msn_rem_permit( struct gaim_connection *gc, char *who )
-{
-	msn_buddy_list_remove( gc, "AL", who );
-}
-
-static void msn_add_deny( struct gaim_connection *gc, char *who )
+static void msn_keepalive( struct im_connection *ic )
+{
+	msn_write( ic, "PNG\r\n", strlen( "PNG\r\n" ) );
+}
+
+static void msn_add_permit( struct im_connection *ic, char *who )
+{
+	msn_buddy_list_add( ic, "AL", who, who );
+}
+
+static void msn_rem_permit( struct im_connection *ic, char *who )
+{
+	msn_buddy_list_remove( ic, "AL", who );
+}
+
+static void msn_add_deny( struct im_connection *ic, char *who )
 {
 	struct msn_switchboard *sb;
 	
-	msn_buddy_list_add( gc, "BL", who, who );
+	msn_buddy_list_add( ic, "BL", who, who );
 	
 	/* If there's still a conversation with this person, close it. */
-	if( ( sb = msn_sb_by_handle( gc, who ) ) )
+	if( ( sb = msn_sb_by_handle( ic, who ) ) )
 	{
 		msn_sb_destroy( sb );
@@ -345,13 +345,13 @@
 }
 
-static void msn_rem_deny( struct gaim_connection *gc, char *who )
-{
-	msn_buddy_list_remove( gc, "BL", who );
-}
-
-static int msn_send_typing( struct gaim_connection *gc, char *who, int typing )
+static void msn_rem_deny( struct im_connection *ic, char *who )
+{
+	msn_buddy_list_remove( ic, "BL", who );
+}
+
+static int msn_send_typing( struct im_connection *ic, char *who, int typing )
 {
 	if( typing )
-		return( msn_send_im( gc, who, TYPING_NOTIFICATION_MESSAGE, strlen( TYPING_NOTIFICATION_MESSAGE ), 0 ) );
+		return( msn_send_im( ic, who, TYPING_NOTIFICATION_MESSAGE, 0 ) );
 	else
 		return( 1 );
@@ -361,17 +361,17 @@
 {
 	account_t *acc = set->data;
-	struct gaim_connection *gc = acc->gc;
+	struct im_connection *ic = acc->ic;
 	struct msn_data *md;
 	char buf[1024], *fn;
 	
 	/* Double-check. */
-	if( gc == NULL )
+	if( ic == NULL )
 		return NULL;
 	
-	md = gc->proto_data;
+	md = ic->proto_data;
 	
 	if( strlen( value ) > 129 )
 	{
-		serv_got_crap( gc, "Maximum name length exceeded" );
+		serv_got_crap( ic, "Maximum name length exceeded" );
 		return NULL;
 	}
@@ -379,6 +379,6 @@
 	fn = msn_http_encode( value );
 	
-	g_snprintf( buf, sizeof( buf ), "REA %d %s %s\r\n", ++md->trId, gc->username, fn );
-	msn_write( gc, buf, strlen( buf ) );
+	g_snprintf( buf, sizeof( buf ), "REA %d %s %s\r\n", ++md->trId, ic->username, fn );
+	msn_write( ic, buf, strlen( buf ) );
 	g_free( fn );
 	
@@ -389,5 +389,5 @@
 }
 
-void msn_init()
+void msn_initmodule()
 {
 	struct prpl *ret = g_new0(struct prpl, 1);
@@ -395,12 +395,12 @@
 	ret->name = "msn";
 	ret->login = msn_login;
-	ret->acc_init = msn_acc_init;
-	ret->close = msn_close;
+	ret->init = msn_init;
+	ret->logout = msn_logout;
 	ret->send_im = msn_send_im;
 	ret->away_states = msn_away_states;
 	ret->get_status_string = msn_get_status_string;
 	ret->set_away = msn_set_away;
-	ret->set_info = msn_set_info;
 	ret->get_info = msn_get_info;
+	ret->set_my_name = msn_set_my_name;
 	ret->add_buddy = msn_add_buddy;
 	ret->remove_buddy = msn_remove_buddy;
@@ -408,5 +408,5 @@
 	ret->chat_invite = msn_chat_invite;
 	ret->chat_leave = msn_chat_leave;
-	ret->chat_open = msn_chat_open;
+	ret->chat_with = msn_chat_with;
 	ret->keepalive = msn_keepalive;
 	ret->add_permit = msn_add_permit;
Index: protocols/msn/msn.h
===================================================================
--- protocols/msn/msn.h	(revision fa29d09342c79b886efacee4cfc3078be5f5a722)
+++ protocols/msn/msn.h	(revision 0da65d5fb37691ed4d31f7ab4058732f1440db6b)
@@ -57,5 +57,5 @@
 struct msn_data
 {
-	struct gaim_connection *gc;
+	struct im_connection *ic;
 	
 	int fd;
@@ -75,5 +75,5 @@
 struct msn_switchboard
 {
-	struct gaim_connection *gc;
+	struct im_connection *ic;
 	
 	int fd;
@@ -89,5 +89,5 @@
 	GSList *msgq;
 	char *who;
-	struct conversation *chat;
+	struct groupchat *chat;
 };
 
@@ -149,9 +149,9 @@
 
 /* msn_util.c */
-int msn_write( struct gaim_connection *gc, char *s, int len );
-int msn_logged_in( struct gaim_connection *gc );
-int msn_buddy_list_add( struct gaim_connection *gc, char *list, char *who, char *realname );
-int msn_buddy_list_remove( struct gaim_connection *gc, char *list, char *who );
-void msn_buddy_ask( struct gaim_connection *gc, char *handle, char *realname );
+int msn_write( struct im_connection *ic, char *s, int len );
+int msn_logged_in( struct im_connection *ic );
+int msn_buddy_list_add( struct im_connection *ic, char *list, char *who, char *realname );
+int msn_buddy_list_remove( struct im_connection *ic, char *list, char *who );
+void msn_buddy_ask( struct im_connection *ic, char *handle, char *realname );
 char *msn_findheader( char *text, char *header, int len );
 char **msn_linesplit( char *line );
@@ -167,10 +167,10 @@
 /* sb.c */
 int msn_sb_write( struct msn_switchboard *sb, char *s, int len );
-struct msn_switchboard *msn_sb_create( struct gaim_connection *gc, char *host, int port, char *key, int session );
-struct msn_switchboard *msn_sb_by_handle( struct gaim_connection *gc, char *handle );
-struct msn_switchboard *msn_sb_by_chat( struct conversation *c );
-struct msn_switchboard *msn_sb_spare( struct gaim_connection *gc );
+struct msn_switchboard *msn_sb_create( struct im_connection *ic, char *host, int port, char *key, int session );
+struct msn_switchboard *msn_sb_by_handle( struct im_connection *ic, char *handle );
+struct msn_switchboard *msn_sb_by_chat( struct groupchat *c );
+struct msn_switchboard *msn_sb_spare( struct im_connection *ic );
 int msn_sb_sendmessage( struct msn_switchboard *sb, char *text );
-struct conversation *msn_sb_to_chat( struct msn_switchboard *sb );
+struct groupchat *msn_sb_to_chat( struct msn_switchboard *sb );
 void msn_sb_destroy( struct msn_switchboard *sb );
 gboolean msn_sb_connected( gpointer data, gint source, b_input_condition cond );
Index: protocols/msn/msn_util.c
===================================================================
--- protocols/msn/msn_util.c	(revision fa29d09342c79b886efacee4cfc3078be5f5a722)
+++ protocols/msn/msn_util.c	(revision 0da65d5fb37691ed4d31f7ab4058732f1440db6b)
@@ -28,7 +28,7 @@
 #include <ctype.h>
 
-int msn_write( struct gaim_connection *gc, char *s, int len )
-{
-	struct msn_data *md = gc->proto_data;
+int msn_write( struct im_connection *ic, char *s, int len )
+{
+	struct msn_data *md = ic->proto_data;
 	int st;
 	
@@ -36,6 +36,6 @@
 	if( st != len )
 	{
-		hide_login_progress_error( gc, "Short write() to main server" );
-		signoff( gc );
+		hide_login_progress_error( ic, "Short write() to main server" );
+		signoff( ic );
 		return( 0 );
 	}
@@ -44,14 +44,14 @@
 }
 
-int msn_logged_in( struct gaim_connection *gc )
-{
-	account_online( gc );
+int msn_logged_in( struct im_connection *ic )
+{
+	account_online( ic );
 	
 	return( 0 );
 }
 
-int msn_buddy_list_add( struct gaim_connection *gc, char *list, char *who, char *realname_ )
-{
-	struct msn_data *md = gc->proto_data;
+int msn_buddy_list_add( struct im_connection *ic, char *list, char *who, char *realname_ )
+{
+	struct msn_data *md = ic->proto_data;
 	char buf[1024], *realname;
 	
@@ -59,5 +59,5 @@
 	
 	g_snprintf( buf, sizeof( buf ), "ADD %d %s %s %s\r\n", ++md->trId, list, who, realname );
-	if( msn_write( gc, buf, strlen( buf ) ) )
+	if( msn_write( ic, buf, strlen( buf ) ) )
 	{
 		g_free( realname );
@@ -71,11 +71,11 @@
 }
 
-int msn_buddy_list_remove( struct gaim_connection *gc, char *list, char *who )
-{
-	struct msn_data *md = gc->proto_data;
+int msn_buddy_list_remove( struct im_connection *ic, char *list, char *who )
+{
+	struct msn_data *md = ic->proto_data;
 	char buf[1024];
 	
 	g_snprintf( buf, sizeof( buf ), "REM %d %s %s\r\n", ++md->trId, list, who );
-	if( msn_write( gc, buf, strlen( buf ) ) )
+	if( msn_write( ic, buf, strlen( buf ) ) )
 		return( 1 );
 	
@@ -85,5 +85,5 @@
 struct msn_buddy_ask_data
 {
-	struct gaim_connection *gc;
+	struct im_connection *ic;
 	char *handle;
 	char *realname;
@@ -92,8 +92,8 @@
 static void msn_buddy_ask_yes( gpointer w, struct msn_buddy_ask_data *bla )
 {
-	msn_buddy_list_add( bla->gc, "AL", bla->handle, bla->realname );
-	
-	if( find_buddy( bla->gc, bla->handle ) == NULL )
-		show_got_added( bla->gc, bla->handle, NULL );
+	msn_buddy_list_add( bla->ic, "AL", bla->handle, bla->realname );
+	
+	if( find_buddy( bla->ic, bla->handle ) == NULL )
+		show_got_added( bla->ic, bla->handle, NULL );
 	
 	g_free( bla->handle );
@@ -104,5 +104,5 @@
 static void msn_buddy_ask_no( gpointer w, struct msn_buddy_ask_data *bla )
 {
-	msn_buddy_list_add( bla->gc, "BL", bla->handle, bla->realname );
+	msn_buddy_list_add( bla->ic, "BL", bla->handle, bla->realname );
 	
 	g_free( bla->handle );
@@ -111,10 +111,10 @@
 }
 
-void msn_buddy_ask( struct gaim_connection *gc, char *handle, char *realname )
+void msn_buddy_ask( struct im_connection *ic, char *handle, char *realname )
 {
 	struct msn_buddy_ask_data *bla = g_new0( struct msn_buddy_ask_data, 1 );
 	char buf[1024];
 	
-	bla->gc = gc;
+	bla->ic = ic;
 	bla->handle = g_strdup( handle );
 	bla->realname = g_strdup( realname );
@@ -123,5 +123,5 @@
 	            "The user %s (%s) wants to add you to his/her buddy list.",
 	            handle, realname );
-	do_ask_dialog( gc, buf, bla, msn_buddy_ask_yes, msn_buddy_ask_no );
+	do_ask_dialog( ic, buf, bla, msn_buddy_ask_yes, msn_buddy_ask_no );
 }
 
